/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package TP;

import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.TextMessage;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

/**
 *
 * @author Yanet
 */
@MessageDriven(mappedName = "jms/MessageJMS", activationConfig =  {
        @ActivationConfigProperty(propertyName = "acknowledgeMode", propertyValue = "Auto-acknowledge"),
        @ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Queue"),
        @ActivationConfigProperty(propertyName = "clientId", propertyValue = "MessageJMSBean"),
        @ActivationConfigProperty(propertyName = "subscriptionName", propertyValue = "MessageJMSBean")

    })
public class MessageJMSBean implements MessageListener {
    
    public MessageJMSBean() {
    }

    @PersistenceContext
    private EntityManager em;


    public void onMessage(Message msg) {
        if(msg instanceof OperationBancaire) {
            OperationBancaire op = (OperationBancaire) msg;
              String date = op.getDates();
              String descriptif = op.getDescriptif();
              String type = op.getType();
              String montant = op.getMontant();
              System.out.println("--------Received new message :----"  + date + descriptif);
              em.persist(op);
        }

}
}
