/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package TP;

import java.math.BigDecimal;
import java.util.Collection;
import javax.ejb.Stateful;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

/**
 *
 * @author Yanet
 */
@Stateful
public class GestionnaireDeCompteBancairesBean implements GestionnaireDeCompteBancairesLocal {
    @PersistenceContext
    private EntityManager em;
    // Add business logic below. (Right-click in editor and choose
    // "Insert Code > Add Business Method" or "Web Service > Add Operation")

 public void creerCompte(CompteBancaire c) {
    em.persist(c);
  }

  public Collection  afficherCompte() {
        Query query = em.createNamedQuery("CompteBancaire.findAll");
        Collection< CompteBancaire > result = query.getResultList();
        return result;
  }

  public void transfertCompte(CompteBancaire cFrom,CompteBancaire cTo,String montantValue ) {
        Long idFromValue= cFrom.getId();
        Long idToValue= cTo.getId();
        CompteBancaire resultFrom = em.find(CompteBancaire.class, idFromValue);
        CompteBancaire resultTo = em.find(CompteBancaire.class, idToValue);
        resultFrom.setSolde(sustraction(resultFrom.getSolde(),montantValue).toString());
        resultTo.setSolde(somme(resultTo.getSolde(),montantValue).toString());
        em.merge(resultFrom);
        em.merge(resultTo);
  }
  public void persist(Object object) {
        em.persist(object);

  }

  public static BigDecimal somme(String a, String b)
	{
		if (a != null)
			a = a.trim();
		if (b != null)
			b = b.trim();
		if ((a != null || b != null) && (!"".equals(a) || !"".equals(b)))
		{
			if (a == null)
				a = "0";
			if (b == null)
				b = "0";
			if ("".equals(a))
				a = "0";
			if ("".equals(b))
				b = "0";
			BigDecimal suma = new BigDecimal(a).add(new BigDecimal(b));
			// suma = suma.setScale(6, BigDecimal.ROUND_HALF_UP);
			return suma;
		}
		else
			return null;
	}

	public static BigDecimal sustraction(String minuendo, String substraendo)
	{
		if (minuendo != null)
			minuendo = minuendo.trim();
		if (substraendo != null)
			substraendo = substraendo.trim();
		if ((minuendo != null || substraendo != null) && (!"".equals(minuendo) || !"".equals(substraendo)))
		{
			if (minuendo == null)
				minuendo = "0";
			if (substraendo == null)
				substraendo = "0";
			if ("".equals(minuendo))
				minuendo = "0";
			if ("".equals(substraendo))
				substraendo = "0";
			BigDecimal resta = new BigDecimal(minuendo).subtract(new BigDecimal(substraendo));
			//resta = resta.setScale(6, BigDecimal.ROUND_HALF_UP);
			return resta;
		}
		else
			return null;
	}

    public static BigDecimal stringToBigDecimal(String string)
	{
		BigDecimal longs = null;
		if (string != null && !"".equals(string.trim()))
		{
			longs = new BigDecimal(string.trim());
		}
		return longs;
	}

    public void transfertCompte(CompteBancaire cFrom, CompteBancaire cTo) {
        throw new UnsupportedOperationException("Not supported yet.");
    }
}
