/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package TP;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Collection;
import javax.ejb.EJB;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author Yanet
 */
public class ServletCompte extends HttpServlet {
    @EJB
    private GestionnaireDeCompteBancairesLocal gestionnaireDeCompteBancairesBean;
   
    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out = response.getWriter();
        try {
            /* TODO output your page here
            out.println("<html>");
            out.println("<head>");
            out.println("<title>Servlet ServletCompte</title>");  
            out.println("</head>");
            out.println("<body>");
            out.println("<h1>Servlet ServletCompte at " + request.getContextPath () + "</h1>");
            out.println("</body>");
            out.println("</html>");
            */
            //gestionnaireDeCompteBancairesBean.creerCompteTest();
            String action = request.getParameter("action");

            if(action.equals("actionCreer")) {
                String nomValue = request.getParameter("nom");
                String soldeValue = request.getParameter("solde");
                CompteBancaire c = new CompteBancaire();
                c.setNom(nomValue);
                c.setSolde(soldeValue);
                gestionnaireDeCompteBancairesBean.creerCompte(c);
                request.setAttribute("CompteBancaires", gestionnaireDeCompteBancairesBean.afficherCompte());
                RequestDispatcher dp = request.getRequestDispatcher("afficheurComptes.jsp");
                dp.forward(request, response);
            }
            if(action.equals("actionAfficher")) {
                Collection compte = gestionnaireDeCompteBancairesBean.afficherCompte();
                request.setAttribute("CompteBancaires", compte);
                RequestDispatcher dp = request.getRequestDispatcher("afficheurComptes.jsp");
                dp.forward(request, response);
            }
            if(action.equals("actionEffectuer")) {
                Long idFromValue = Long.parseLong(request.getParameter("idFrom"));
                Long idToValue = Long.parseLong(request.getParameter("idTo"));
                String montantValue = request.getParameter("montant");
                CompteBancaire cFrom = new CompteBancaire();
                cFrom.setId(idFromValue);
                CompteBancaire cTo = new CompteBancaire();
                cTo.setId(idToValue);
                gestionnaireDeCompteBancairesBean.transfertCompte(cFrom,cTo,montantValue);
                request.setAttribute("CompteBancaires", gestionnaireDeCompteBancairesBean.afficherCompte());
                RequestDispatcher dp = request.getRequestDispatcher("afficheurComptes.jsp");
                dp.forward(request, response);
            }
            if(action.equals("forwardCreer")) {
                RequestDispatcher dp = request.getRequestDispatcher("creerComptes.jsp");
                dp.forward(request, response);
            }
            if(action.equals("forwardTransfert")) {
            request.setAttribute("CompteBancaires", gestionnaireDeCompteBancairesBean.afficherCompte());
            RequestDispatcher dp = request.getRequestDispatcher("transfertComptes.jsp");
                dp.forward(request, response);
            }
            if(action.equals("forwardIndex")) {
                RequestDispatcher dp = request.getRequestDispatcher("index.jsp");
                dp.forward(request, response);
            }
        } finally { 
            out.close();
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    } 

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
